package com.nextbyte.herbtech_printer;

import com.lvrenyang.io.Pos;

import java.util.List;

public class Prints {

    public static int PrintTicket(Pos pos, List<String> data) {
        int bPrintResult = -8;

        byte[] status = new byte[1];
        if (pos.POS_RTQueryStatus(status, 3, 1000, 2)) {

            if ((status[0] & 0x08) == 0x08)   //判断切刀是否异常
                return -2;

            if ((status[0] & 0x40) == 0x40)   //判断打印头是否在正常值范围内
                return -3;


            if (pos.POS_RTQueryStatus(status, 2, 1000, 2)) {
                if ((status[0] & 0x04) == 0x04)    //判断合盖是否正常
                    return -6;
                if ((status[0] & 0x20) == 0x20)    //判断是否缺纸
                    return -5;
                else {
                    pos.POS_Reset();
                    pos.POS_FeedLine();
                    for(int i=0;i<data.size();i++){
                        pos.POS_TextOut(data.get(i)+"\r\n", 3, 24, 1, 1, 0, 0);
                        pos.POS_TextOut("\r\n", 3, 24, 0, 0, 0, 0);
                    }
//                    pos.POS_TextOut("Hello Iqbal\r\n", 3, 24, 1, 1, 0, 0);
//                    pos.POS_TextOut("\r\n", 3, 24, 0, 0, 0, 0);
//                    pos.POS_TextOut("Makhori\r\n", 3, 48, 1, 1, 0, 0);
//                    pos.POS_TextOut("\r\n", 3, 24, 0, 0, 0, 0);
//                    pos.POS_TextOut("How are you\r\n", 3, 60, 1, 1, 0, 0);
//                    pos.POS_TextOut("2016-05-26 09:43:29\r\n", 3, 0, 0, 0, 0, 0);
//                    pos.POS_S_SetBarcode("46661366725", 0, 69, 2, 50, 0, 0);
//                    pos.POS_DoubleQRCode("Iqbal Reverse Twerking", 20, 4, 5, "r=> r.apply() return r;", 230, 4, 5, 4);
//                    pos.POS_S_SetQRcode("Iqbal Reverse Twerking",20,5,1);
                    pos.POS_FeedLine();
                    pos.POS_FeedLine();
                    pos.POS_FeedLine();
                    pos.POS_FeedLine();
                    pos.POS_FeedLine();
                    pos.POS_HalfCutPaper();
                    try {
                        Thread.currentThread();
                        Thread.sleep(500);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }

                    if (pos.POS_RTQueryStatus(status, 1, 1000, 2)) {
                        if ((status[0] & 0x80) == 0x80) {

                            try {
                                Thread.currentThread();
                                Thread.sleep(3000);
                            } catch (InterruptedException e) {
                                e.printStackTrace();
                            }

                            if (pos.POS_RTQueryStatus(status, 2, 1000, 2)) {
                                if ((status[0] & 0x20) == 0x20)    //打印过程缺纸
                                    return -9;
                                if ((status[0] & 0x04) == 0x04)    //打印过程打开纸仓盖
                                    return -10;
                            } else {
                                return -11;         //查询失败
                            }


                            if (pos.POS_RTQueryStatus(status, 4, 1000, 2)) {
                                if ((status[0] & 0x08) == 0x08) {
                                    if (pos.POS_RTQueryStatus(status, 1, 1000, 2)) {
                                        if ((status[0] & 0x80) == 0x80)     //纸将尽且未取纸
                                            return 2;
                                        else
                                            return 1;
                                    }
                                } else {
                                    if (pos.POS_RTQueryStatus(status, 1, 1000, 2)) {
                                        if ((status[0] & 0x80) == 0x80) {
                                            return 3;
                                        } else
                                            return 0;
                                    } else
                                        return -11;
                                }
                            } else {
                                return -11;         //查询失败
                            }


                        } else {
                            try {
                                Thread.currentThread();
                                Thread.sleep(3000);
                            } catch (InterruptedException e) {
                                e.printStackTrace();
                            }

                            if (pos.POS_RTQueryStatus(status, 2, 1000, 2)) {
                                if ((status[0] & 0x20) == 0x20) {
                                    return -9;                //打印过程缺纸
                                }

                                if ((status[0] & 0x04) == 0x04) {
                                    return -10;                //打印过程打开纸仓盖
                                } else {
                                    return -1;
                                }


                            } else {
                                return -11;         //查询失败
                            }
                        }

                    } else {
                        return -11;
                    }
                }

            } else {
                return -8;           //查询失败
            }

        } else {
            return -8;          //查询失败
        }

        return bPrintResult;
    }

    public static String ResultCodeToString(int code) {
        switch (code) {
            case 3:
                return "There is an uncollected receipt at the paper exit, please take out the receipt in time";
            case 2:
                return "The paper is almost out and there is an uncollected receipt at the paper exit, please pay attention to replace the paper roll and take away the receipt in time";
            case 1:
                return "The paper is almost out, please replace the paper roll";
            case 0:
                return " ";
            case -1:
                return "The receipt is not printed, please check if there is a paper jam";
            case -2:
                return "The cutter is abnormal, please remove it manually";
            case -3:
                return "The print head is overheated, please wait for the printer to cool down";
            case -4:
                return "Printer is offline";
            case -5:
                return "Printer is out of paper";
            case -6:
                return "Cover open";
            case -7:
                return "Real-time status query failed";
            case -8:
                return "Failed to check the status, please check whether the communication port is connected normally";
            case -9:
                return "There is no paper during printing, please check the completeness of the documents";
            case -10:
                return "The top cover was opened during printing, please reprint";
            case -11:
                return "The connection is interrupted, please confirm whether the printer is connected";
            case -12:
                return "Please take away the printed receipt before printing!";
            case -13:
            default:
                return "unknown mistake";
        }
    }

}
