

package com.nextbyte.herbtech_printer;

import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.hardware.usb.UsbDevice;
import android.hardware.usb.UsbManager;
import android.widget.Toast;

import com.lvrenyang.io.Pos;
import com.lvrenyang.io.USBPrinting;
import com.lvrenyang.io.base.IOCallBack;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class Snippet implements IOCallBack {
    Pos mPos = new Pos();//used
    USBPrinting mUsb = new USBPrinting();//used
    ExecutorService es = Executors.newScheduledThreadPool(30);//used
    final List<String> data;



    Snippet(List<String> data){
        this.data = data;
    }

    String print(Context context) {
        System.out.println("Starting print");
        final UsbManager mUsbManager = (UsbManager) context.getSystemService(Context.USB_SERVICE);
        mPos.Set(mUsb);
        mUsb.SetCallBack(this);
        HashMap<String, UsbDevice> deviceList = mUsbManager.getDeviceList();
        Iterator<UsbDevice> deviceIterator = deviceList.values().iterator();
        if (!deviceIterator.hasNext()) {
            System.out.println("No printer found");
            return "No printer found";
        }

        final UsbDevice device = deviceIterator.next();
        if (!mUsbManager.hasPermission(device)) {
            System.out.println("No permission, requesting permission");

            PendingIntent mPermissionIntent = PendingIntent
                    .getBroadcast(
                            context,
                            0,
                            new Intent(
                                    context
                                            .getApplicationInfo().packageName),
                            0);
            mUsbManager.requestPermission(device,
                    mPermissionIntent);
            return "Permission denied";
        } else {
            System.out.println("Permission yes, submitted");
            Toast.makeText(context, "Connecting...", Toast.LENGTH_SHORT).show();
            es.submit(new TaskOpen(mUsb,mUsbManager,device,context));
        }

        return "Success";
    }

    @Override
    public void OnOpen() {
        System.out.println("Opened, printing");
        es.submit(new TaskPrint(mPos));
    }

    @Override
    public void OnOpenFailed() {

    }

    @Override
    public void OnClose() {

    }

    public class TaskPrint implements Runnable
    {
        Pos pos = null;

        public TaskPrint(Pos pos)
        {
            this.pos = pos;
        }

        @Override
        public void run() {
            System.out.println("Running...");
            final int bPrintResult = Prints.PrintTicket(pos,data);
            final boolean bIsOpened = pos.GetIO().IsOpened();
        }

    }

    public static class TaskOpen implements Runnable
    {
        USBPrinting usb = null;
        UsbManager usbManager = null;
        UsbDevice usbDevice = null;
        Context context = null;

        public TaskOpen(USBPrinting usb, UsbManager usbManager, UsbDevice usbDevice, Context context)
        {
            this.usb = usb;
            this.usbManager = usbManager;
            this.usbDevice = usbDevice;
            this.context = context;
        }

        @Override
        public void run() {
            // TODO Auto-generated method stub
            usb.Open(usbManager,usbDevice,context);
        }
    }
}
